<?php

namespace Modules\DF\Controllers;

use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;
use Modules\DF\Services\Guia as Service;

class Guia{
    
    protected $service;
    public $guia_exists = array();
    
    
    public function __construct(Service $service) {
        $this->service = $service;
    }

    public function guide(Request $request, Response $response){
        $query = $request->getParameters();
        
        $returnValidations = $this->service->validateGuideFilter($query);
        
        if(sizeof($returnValidations["errors"]) > 0){
            return $this->getResponse("E", [], $returnValidations["errors"], $response);
        }else{
            $query = $returnValidations["guideUpdated"];
            $guides = $this->service->getGuides($query);
            if(sizeof($guides["errors"]) > 0){
                return $this->getResponse("E", [], $guides["errors"], $response);
            }else{
                return $this->getResponse("S", $guides["taxes"], [], $response);
            }
            
        }
        
    }
    
    
    
    public function getResponse($status, $messages, $keys, &$response){
        $retorno = array();
        $retorno["STATUS"] = $status;
        $retorno["MENSAGEM"] = $messages;
        $retorno["KEYS"] = $keys;
        header('Content-Type: application/json; charset=utf-8');
        $response->setMetadata($retorno);
    }
}