<?php
namespace Modules\DF\Services;

use Teknisa\Libs\Util\NewCode;
use Modules\DF\Factories\Lancamento as Factory;
use Modules\DF\Services\ValidacoesEstoqueService as EstoqueService;
use Modules\DF\Services\ConfereErrosAvisosNota as ErrosAvisos;
use Zeedhi\Framework\DB\StoredProcedure\Param;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use \Zeedhi\Framework\ORM\DateTime;
use \Geral\Util\DateUtil;
use Estoque\Entities\Lanctoestoq;
use \Estoque\Entities\Itlanctoest;
use Geral\Entities\Produto;
use \Estoque\Entities\Movilote;
use Zeedhi\Framework\Remote\FileUploader\Server as fileUploader;

class Lancamento{
    public $geraFaturaDevolucao = false;
    public $existeAfLancada = false;
    public $cdempresa = null;
    public $tax_struct = array(
        
            "CDFILIALORIG" => array(
                                    "TYPE" => "string",
                                    "SIZE" => "4",
                                    "REQUIRED" => true
                                    ),
            "NRAUTOFORN" => array(
                                    "TYPE" => "string",
                                    "SIZE" => "10",
                                    "REQUIRED" => false
                                    ),
            "IDENTRSAIDOP" => array(
                                    "TYPE" => "string",
                                    "SIZE" => "1",
                                    "REQUIRED" => true
                                    ),
            "CDTIPOOPER" => array(
                                    "TYPE" => "string",
                                    "SIZE" => "2",
                                    "REQUIRED" => true
                                    ),
            "VRNOTAFISC" => array(
                                    "TYPE" => "double",
                                    "SIZE" => "INDEFINIDO",
                                    "REQUIRED" => false
                                    ),
            "DTENTRSAID" => array(
                                    "TYPE" => "dd/mm/yyyy",
                                    "SIZE" => "10",
                                    "REQUIRED" => true
                                    ),
            "DTEMISSAO" => array(
                                    "TYPE" => "dd/mm/yyyy",
                                    "SIZE" => "10",
                                    "REQUIRED" => true
                                    ),
            "NRINSJURFORN" => array(
                                    "TYPE" => "string",
                                    "SIZE" => "10",
                                    "REQUIRED" => false
                                    ),
            "CDFILIALDEST" => array(
                                    "TYPE" => "string",
                                    "SIZE" => "4",
                                    "REQUIRED" => false
                                    ),
            "CDSERIE" => array(
                                    "TYPE" => "string",
                                    "SIZE" => "5",
                                    "REQUIRED" => true
                                    ),
            "NRNOTAFISC" => array(
                                    "TYPE" => "string",
                                    "SIZE" => "20",
                                    "REQUIRED" => false
                                    ),
            "CDOPERADOR" => array(
                                    "TYPE" => "string",
                                    "SIZE" => "12",
                                    "REQUIRED" => true
                                    ),
            "CUSTOMVAR1" => array(
                                    "TYPE" => "string",
                                    "SIZE" => "100",
                                    "REQUIRED" => false
                                    ),       
            "CUSTOMVAR2" => array(
                                    "TYPE" => "string",
                                    "SIZE" => "100",
                                    "REQUIRED" => false
                                    ),       
            "CUSTOMDATE1" => array(
                                    "TYPE" => "dd/mm/yyyy",
                                    "SIZE" => "INDEFINIDO",
                                    "REQUIRED" => false
                                    ),       
            "CUSTOMFLOAT1" => array(
                                    "TYPE" => "double",
                                    "SIZE" => "INDEFINIDO",
                                    "REQUIRED" => false
                                    ),       
            "CUSTOMFLOAT2" => array(
                                    "TYPE" => "double",
                                    "SIZE" => "INDEFINIDO",
                                    "REQUIRED" => false
                                    ),       
            "CUSTOMBOOL1" => array(
                                    "TYPE" => "number",
                                    "SIZE" => "1",
                                    "REQUIRED" => false
                                    ),    
            "ANEXO" => array(
                                    "TYPE" => "string",
                                    "SIZE" => "INDEFINIDO",
                                    "REQUIRED" => false
                                    ), 
            "CUSTOMCLOB1" => array(
                                    "TYPE" => "string",
                                    "SIZE" => "INDEFINIDO",
                                    "REQUIRED" => false
                                    ),  
            "Produtos" => array(
                                "TYPE" => "array",
                                "SIZE" => "INDEFINIDO",
                                "REQUIRED" => true
                                ), 
            "Encargos" => array(
                                "TYPE" => "array",
                                "SIZE" => "INDEFINIDO",
                                "REQUIRED" => false
                                ),  
            "DadosAdicionais" => array(
                                        "TYPE" => "array",
                                        "SIZE" => "INDEFINIDO",
                                        "REQUIRED" => false
                                        )
        );
    public $prod_struct = array(
                      
                "CDPRODUTO" => array(
                                        "TYPE" => "string",
                                        "SIZE" => "20",
                                        "REQUIRED" => true
                                        ),
                "QTITEMPROD" => array(
                                        "TYPE" => "double",
                                        "OBS" => 5,
                                        "SIZE" => "APOS",
                                        "REQUIRED" => true
                                        ),
                "QTRECEBE" => array(
                                        "TYPE" => "double",
                                        "OBS" => 5,
                                        "SIZE" => "APOS",
                                        "REQUIRED" => true
                                        ),
                "VRUNITITEM" => array(
                                        "TYPE" => "double",
                                        "SIZE" => "INDEFINIDO",
                                        "REQUIRED" => false
                                        ),
                "VRTOTAITEM" => array(
                                        "TYPE" => "double",
                                        "SIZE" => "INDEFINIDO",
                                        "REQUIRED" => false
                                        ),
                "VRDESCITEM" => array(
                                        "TYPE" => "double",
                                        "SIZE" => "INDEFINIDO",
                                        "REQUIRED" => false
                                        ),
                "NRLOTEESTQ" => array(
                                        "TYPE" => "string",
                                        "SIZE" => "20",
                                        "REQUIRED" => false
                                        ),
                "NRSUBLOTE" => array(
                                        "TYPE" => "string",
                                        "SIZE" => "4",
                                        "REQUIRED" => false
                                        ),
                "CDALMOXARIFE" => array(
                                        "TYPE" => "string",
                                        "SIZE" => "6",
                                        "REQUIRED" => false
                                        ),
                "CDLOCALESTOQ" => array(
                                                    "TYPE" => "string",
                                                    "SIZE" => "6",
                                                    "REQUIRED" => false
                                                    ),
                "CUSTOMVAR3" => array(
                                    "TYPE" => "string",
                                    "SIZE" => "100",
                                    "REQUIRED" => false
                                    )
            );
    public $charge_struct = array(
        "CDENCARGO" => array(
                                "TYPE" => "string",
                                "SIZE" => "2",
                                "REQUIRED" => true
                                ),
        "VRITEMENCA" => array(
                                "TYPE" => "double",
                                "SIZE" => "INDEFINIDO",
                                "REQUIRED" => true
                                )
        );
    public $dac_struct = array(
        "DSDADOADIC" => array(
                                "TYPE" => "string",
                                "SIZE" => "3000",
                                "REQUIRED" => true
                                )
        );
    public $devolucao = false;
    public $baixouAf = false;
    protected $taxErrors = array();
    protected $entryErrors = array();
    protected $closeErrors = array();
    protected $entityManager;
    protected $confereErros; 

    public function __construct(\Doctrine\ORM\EntityManager $entityManager, Factory $factory, $environment, $crudService, ErrosAvisos $confereErros, EstoqueService $estoque)  {
        $this->entityManager = $entityManager;
        $this->factory = $factory;
        $this->environment = $environment;
        $this->crudService = $crudService;
        $this->confereErrosAvisosNota = $confereErros;
        $this->estoque = $estoque;
    }
    
    public function getPrimaryKeys($tax){
        if(!array_key_exists("CDTIPOOPER", $tax)){
            array_push($this->taxErrors, "O CDTIPOOPER não foi informado e é obrigatório.");
            return array("taxUpdated" => [], "errors" => $this->taxErrors);
        }
        
        if(!array_key_exists("IDENTRSAIDOP", $tax)){
            array_push($this->taxErrors, "O IDENTRSAIDOP não foi informado e é obrigatório.");
            return array("taxUpdated" => [], "errors" => $this->taxErrors);
        }
        
        $identrsaidopError = $this->validateIdentifyTax($tax["IDENTRSAIDOP"]);
        if($identrsaidopError != false){
            array_push($this->taxErrors, $identrsaidopError);
            return array("taxUpdated" => [], "errors" => $this->taxErrors);
        }
            
        $identrsaidopError = $this->validateTipooperTax($tax["CDTIPOOPER"]);
        if($identrsaidopError != false){
            array_push($this->taxErrors, $identrsaidopError);
            return array("taxUpdated" => [], "errors" => $this->taxErrors);
        }
        
        $found = $this->factory->validaCDTIPOOPER($tax["CDTIPOOPER"], $tax["IDENTRSAIDOP"]);
        if($found == false){
            array_push($this->taxErrors, 'O CDTIPOOPER não existe no banco de dados. ' . $tax["CDTIPOOPER"]);
            return array("taxUpdated" => [], "errors" => $this->taxErrors);
        }
        
        if($tax["CDTIPOOPER"] == "01" && $tax["IDENTRSAIDOP"] == 'E'){
            if(!array_key_exists("CDFILIALORIG", $tax)){
                array_push($this->taxErrors, "O CDFILIALORIG não foi informado e é obrigatório.");
                return array("taxUpdated" => [], "errors" => $this->taxErrors);
            }else{
                $tax["CDFILIAL"] = $tax["CDFILIALORIG"];
                $tax["CDFILIRECE"] = $tax["CDFILIALORIG"];
                $tax["CDFILIEMIT"] = NULL;
            }
            
        }else if($tax["CDTIPOOPER"] == "02" && $tax["IDENTRSAIDOP"] == 'E'){
            if(!array_key_exists("CDFILIALDEST", $tax)){
                array_push($this->taxErrors, "O CDFILIALDEST não foi informado e é obrigatório.");
                return array("taxUpdated" => [], "errors" => $this->taxErrors);
            }else{
                $tax["CDFILIAL"] = $tax["CDFILIALDEST"];
                $tax["CDFILIRECE"] = $tax["CDFILIALDEST"];
            }
            if(!array_key_exists("CDFILIALORIG", $tax)){
                array_push($this->taxErrors, "O CDFILIALORIG não foi informado e é obrigatório.");
                return array("taxUpdated" => [], "errors" => $this->taxErrors);
            }else{
                $tax["CDFILIEMIT"] = $tax["CDFILIALORIG"];
        	    $tax["CDFORNECED"] =  $tax["CDFILIALORIG"];
                $tax["CDCLIENTE"] = $tax["CDFILIALORIG"];
            }
            
        }else if($tax["CDTIPOOPER"] == "02" && $tax["IDENTRSAIDOP"] == 'S'){
            if(!array_key_exists("CDFILIALDEST", $tax)){
                array_push($this->taxErrors, "O CDFILIALDEST não foi informado e é obrigatório.");
                return array("taxUpdated" => [], "errors" => $this->taxErrors);
            }else{
        	    $tax["CDFILIRECE"] = $tax["CDFILIALDEST"];
        	    $tax["CDFORNECED"] =  $tax["CDFILIALDEST"];
                $tax["CDCLIENTE"] = $tax["CDFILIALDEST"];
            }
            
            if(!array_key_exists("CDFILIALORIG", $tax)){
                array_push($this->taxErrors, "O CDFILIALORIG não foi informado e é obrigatório.");
                return array("taxUpdated" => [], "errors" => $this->taxErrors);
            }else{
                $tax["CDFILIAL"] = $tax["CDFILIALORIG"];
                $tax["CDFILIEMIT"] = $tax["CDFILIALORIG"];
            }
        }else if($tax["CDTIPOOPER"] == "01" && $tax["IDENTRSAIDOP"] == 'S'){
            array_push($this->taxErrors, "O CDTIPOOPER " . $tax["CDTIPOOPER"] . " não é válido para notas de saída.");
            return array("taxUpdated" => [], "errors" => $this->taxErrors);
        }
        return array("taxUpdated" => $tax, "errors" => $this->taxErrors);
    }
    
    public function validateTax($tax, $products, $charges = array(), $dacs = array()){
        $this->estandarChangeRequired($tax, $products);
        $this->validateQtRecebeField($tax["CDTIPOOPER"], $products);
        
        $tax_cp = $tax;
        $products_cp = $products;
        
        foreach($this->tax_struct as $field_struct_name => $field_struct_value){
            if($field_struct_name == "Produtos" || $field_struct_name == "Encargos" || $field_struct_name == "DadosAdicionais"){
                continue;
            }
            if(array_key_exists($field_struct_name, $tax)){
                $field_value = $tax[$field_struct_name];
                $this->validateRequired($this->tax_struct, $field_struct_name, $field_value, null);
                
                if($field_value != '' && isset($field_value)){
                    if($field_struct_name == 'ANEXO' || $field_struct_name == 'CUSTOMCLOB1'){
                        $base64 = $this->validate64base($field_value);
                        if($base64 == false){
                            array_push($this->taxErrors, 'O ' . $field_struct_name . ' não é um base64 válido.');
                        }
                    }
                    
                    if(
                        $field_struct_name == 'DTENTRSAID' 
                    ||  $field_struct_name == 'DTEMISSAO'
                    ||  $field_struct_name == 'CUSTOMDATE1'){
                        
                        $field_valueExploded = explode('/', $field_value);
                        if(sizeof($field_valueExploded) != 3){
                            array_push($this->taxErrors, 'O ' .$field_struct_name. ' não corresponde ao formato de data especificado. Formato requerido: '. $this->tax_struct[$field_struct_name]["TYPE"] . '. Formato do atributo: ' . $field_value . '.');
                        }else{
                            $dtComHora = explode(' ', $field_valueExploded[2]);
                            if(sizeof($dtComHora) > 1){
                                $field_valueExploded[2] = $dtComHora[0];
                            }
                            $field_value = date_create("{$field_valueExploded[0]}-{$field_valueExploded[1]}-{$field_valueExploded[2]}");
                            if($field_value != false){
                                if(!$this->validateDate($field_value->format('d/m/Y'), 'd/m/Y')){
                                    array_push($this->taxErrors, 'O ' .$field_struct_name. ' não corresponde ao formato de data especificado. Formato requerido: '. $this->tax_struct[$field_struct_name]["TYPE"] . '. Formato do atributo: ' . $field_value . '.');
                                }
                                $field_value = $tax_cp[$field_struct_name] = $field_value->format('d/m/Y');
                            }else{
                                 array_push($this->taxErrors, 'O ' .$field_struct_name. ' não corresponde ao formato de data especificado. Formato do atributo: ' . $field_value . '.');
                            }
                        }
                    }else if($field_struct_name == 'CUSTOMBOOL1'){
                        if(!is_numeric($field_value)){
                            array_push($this->taxErrors, 'O ' .$field_struct_name. ' não corresponde ao tipo de variável especificado. Tipo recebido: ' .gettype($field_value). '.'. ' Tipo requerido: '. $this->tax_struct[$field_struct_name]["TYPE"] . '. Valor do atributo: ' . $field_value . '.');
                        }
                    }else{
                        //$this->validateType($this->tax_struct, $field_struct_name, $field_value);
                    }
                    //$this->validateSize($this->tax_struct, $field_struct_name, $field_value);
                }
                
                if($field_struct_name == "NRAUTOFORN"){
                    if($tax["CDTIPOOPER"] == "01"){
                        $found = $this->factory->validaAF($tax[$field_struct_name]);
                        if($found == true){
                            $this->existeAfLancada = true;
                        }else{
                            array_push($this->taxErrors, "O número da autorização de fornecimento não foi encontrado ou já foi baixada totalmente.");
                        }
                        
                    }else{
                        $tax_cp["NRAUTOFORN"] = '';
                    }
                }
                
                if($field_struct_name == "VRNOTAFISC"){
                    $tax_cp["VRNOTAFISC"] = $tax[$field_struct_name] == '' ? "0" : $tax_cp["VRNOTAFISC"];
                    $this->verifyNegativeValue($tax[$field_struct_name], $field_struct_name, null);
                }
                
                if($field_struct_name == "CDFILIALORIG"){
                    $found = $this->factory->validaCDFILIAL($tax[$field_struct_name]);
                    if($found == false){
                        array_push($this->taxErrors, 'O ' . $field_struct_name . ' não existe no banco de dados. ' . $tax[$field_struct_name]);
                    }
                }
                
                if($field_struct_name == "CDFILIALDEST" && $tax["CDTIPOOPER"] == "02"){
                    $found = $this->factory->validaCDFILIAL($tax[$field_struct_name]);
                    if($found == false){
                        array_push($this->taxErrors, 'O ' . $field_struct_name . ' não existe no banco de dados. ' . $tax[$field_struct_name]);
                    }
                }
                
                if(!isset($tax["CDEMPRESA"])){
                    $filial = ($tax["IDENTRSAIDOP"] == 'E' && $tax["CDTIPOOPER"] == '01') ? $tax["CDFILIRECE"] : $tax["CDFILIEMIT"];
                    $found = $this->factory->validaCDFILIAL($filial);
                    if($found != false){
                        $tax_cp["CDEMPRESA"] = $found["CDEMPRESA"];
                        $tax_cp["CDINSCESTA"] = $found["CDINSCESTA"];
                        $tax_cp["CDINSCMUNI"] = $found["CDINSCMUNI"];
                    }else{
                        array_push($this->taxErrors, 'Dados da empresa não encontrados.');
                    }
                }
                
                if($field_struct_name == "NRINSJURFORN" && $tax["CDTIPOOPER"] == '01' && $tax["IDENTRSAIDOP"] == 'E'){
                    $found = $this->factory->validaCDFORNECED($tax[$field_struct_name]);
                    if($found == false){
                        array_push($this->taxErrors, 'O ' . $field_struct_name . ' não existe no banco de dados. ' . $tax[$field_struct_name]);
                    }else{
                        $tax_cp["CDFORNECED"] =  $found["CDFORNECED"];
                        $tax_cp["CDCLIENTE"] = $found["CDFORNECED"];
                    }
                }
    
                if($field_struct_name == "CDSERIE"){
                    if($tax["IDENTRSAIDOP"] == 'E'){
                        $found = $this->factory->validaCDSERIEE($tax[$field_struct_name]);
                        if($found == false){
                            array_push($this->taxErrors, 'O ' . $field_struct_name . ' não existe no banco de dados. ' . $tax[$field_struct_name]);
                        }
                    }else{
                        $found = $this->factory->validaCDSERIES($tax[$field_struct_name], $tax_cp["CDEMPRESA"], $tax_cp["CDINSCESTA"], $tax_cp["CDINSCMUNI"]);
                        if($found == false){
                            array_push($this->taxErrors, 'O ' . $field_struct_name . ' não existe no banco de dados. ' . $tax[$field_struct_name]);
                        }
                    }
                }
    
                if($field_struct_name == "NRNOTAFISC"){
                    if(!isset($tax[$field_struct_name]) || $tax[$field_struct_name] == ''){
                        $tax_cp[$field_struct_name] = '';
                    }else{
                        $tax_cp["CDFORNECED"] = isset($tax_cp["CDFORNECED"]) ? $tax_cp["CDFORNECED"] : "";
                        $found = $this->factory->validaNRNOTAFISC($tax[$field_struct_name], $tax_cp["CDFORNECED"]);
                        if($found != false){
                            array_push($this->taxErrors, 'O ' . $field_struct_name . ' já está cadastrado para esse fornecedor. ' . $tax[$field_struct_name]);
                        }
                    }
                }
                
                if($field_struct_name == "CDOPERADOR"){
                    $found = $this->factory->validaCDOPERADOR($tax[$field_struct_name]);
                    if($found == false){
                        array_push($this->taxErrors, 'O ' . $field_struct_name . ' não existe no banco de dados. ' . $tax[$field_struct_name]);
                    }
                }
                
                if($field_struct_name == 'Encargos'){
                    if(!isset($tax[$field_struct_name]) || $tax[$field_struct_name] == ''){
                        $tax_cp[$field_struct_name] = [];
                    }
                }
                
                if($field_struct_name == 'DadosAdicionais'){
                    if(!isset($tax[$field_struct_name]) || $tax[$field_struct_name] == ''){
                        $tax_cp[$field_struct_name] = [];
                    }
                }
            }else{
                if($this->tax_struct[$field_struct_name]["REQUIRED"] == true){
                    array_push($this->taxErrors, 'O ' .$field_struct_name. ' é obrigatório e não foi informado na nota fiscal.');   
                }else{
                    if($field_struct_name == 'NRAUTOFORN'){
                        $tax_cp["NRAUTOFORN"] = '';
                    }
                    
                    if($field_struct_name == "NRNOTAFISC"){
                        $tax_cp[$field_struct_name] = null;
                    }
                    
                    if($field_struct_name == "VRNOTAFISC"){
                        $tax_cp[$field_struct_name] = '';
                    }
                    
                    if($field_struct_name == "NRINSJURFORN"){
                        $tax_cp[$field_struct_name] = '';
                    }
                    
                    if($field_struct_name == 'CUSTOMVAR1'){
                        $tax_cp[$field_struct_name] = '';
                    }
                    
                    if($field_struct_name == 'CUSTOMVAR2'){
                        $tax_cp[$field_struct_name] = '';
                    }
                    
                    if($field_struct_name == 'CUSTOMDATE1'){
                        $tax_cp[$field_struct_name] = '';
                    }
                    
                    if($field_struct_name == 'CUSTOMFLOAT1'){
                        $tax_cp[$field_struct_name] = '';
                    }
                    
                    if($field_struct_name == 'CUSTOMBOOL1'){
                        $tax_cp[$field_struct_name] = '';
                    }
                    
                    if($field_struct_name == 'CUSTOMCLOB1'){
                        $tax_cp[$field_struct_name] = '';
                    }
                    
                    if($field_struct_name == 'ANEXO'){
                        $tax_cp[$field_struct_name] = '';
                    }
                    
                    if($field_struct_name == 'Encargos'){
                        $tax_cp[$field_struct_name] = [];
                    }
                    
                    if($field_struct_name == 'DadosAdicionais'){
                        $tax_cp[$field_struct_name] = [];
                    }
                }
                
            }
            
            if(sizeof($this->taxErrors) > 0){
                return array("messages" => $this->taxErrors, "taxAjusted" => []);
            }
        }
        if(sizeof($this->taxErrors) > 0){
            return array("messages" => $this->taxErrors, "taxAjusted" => []);
        }
        foreach($this->prod_struct as $field_struct_name => $field_struct_value){
            if(sizeof($products) <= 0){
                array_push($this->taxErrors, 'Os produtos da nota fiscal não foram informados. Parâmetro obrigatório.');
                return $this->taxErrors;    
            }
            $index = 0;
            foreach($products as $product){
                if(array_key_exists($field_struct_name, $product)){
                    $field_value = $product[$field_struct_name];
                    
                    if($this->prod_struct[$field_struct_name]["REQUIRED"] == true){
                        $cdproduto = isset($product["CDPRODUTO"]) ? $product["CDPRODUTO"] : "CDPRODUTO não informado.";
                        $this->validateRequired($this->prod_struct, $field_struct_name, $field_value, $cdproduto, 'products');  
                    }
                    if($field_value != '' && isset($field_value)){
                        //$this->validateType($this->prod_struct, $field_struct_name, $field_value);
                        //$this->validateSize($this->prod_struct, $field_struct_name, $field_value);
                    }else{
                        if($field_struct_name == "CDLOCALESTOQ"){
                        $products_cp[$index]["CDLOCALESTOQ"] = " ";
                        }
                        if($field_struct_name == "CDALMOXARIFE"){
                            $products_cp[$index]["CDALMOXARIFE"] = " ";
                        }
                        if($field_struct_name == "NRLOTEESTQ"){
                            $products_cp[$index]["NRLOTEESTQ"] = " ";
                        }
                        if($field_struct_name == "NRSUBLOTE"){
                            $products_cp[$index]["NRSUBLOTE"] = " ";
                        }
                    }
                    if($field_struct_name == "CDPRODUTO"){
                        $produto = $this->factory->getInfosProducts($product[$field_struct_name]);
                        if($produto != false){
                            $products_cp[$index]["CDPRODUTO"] = $produto['CDPRODUTO'];
                            $products_cp[$index]["CDARVPROD"] = $produto['CDARVPROD'];
                            $products_cp[$index]["CDPRODESTO"] = $produto['CDPRODESTO'];
                            $products_cp[$index]["DSPRODEMIS"] = $produto['NMPRODUTO'];
                        }else{
                            array_push($this->taxErrors, 'O produto ' . $products_cp[$index][$field_struct_name] . ' não é um produto válido na base Teknisa não está ativo no sistema. "Produto".');
                        }
                    }
                    if($field_struct_name == "QTRECEBE"){
                        $this->verifyNegativeValue($products_cp[$index][$field_struct_name], $field_struct_name, $products_cp[$index]["CDARVPROD"]);
                        if($tax["CDTIPOOPER"] == "01"){
                            if($product["QTITEMPROD"] > $product["QTRECEBE"]){
                                $this->devolucao = true;                                            
                            }
                        }else{
                            if($product["QTITEMPROD"] != $product["QTRECEBE"]){
                                array_push($this->taxErrors, "O QTITEMPROD deverá ser igual ao QTRECEBE pois trata-se de uma guia de despacho.");                                            
                            }
                        }
                    }
                }else{
                    $cdproduto = isset($product["CDPRODUTO"]) ? $product["CDPRODUTO"] : "CDPRODUTO não informado.";
                    $this->validateRequired($this->prod_struct, $field_struct_name, $field_value, $cdproduto, 'products');
                    
                    if($field_struct_name == "VRUNITITEM"){
                        $products_cp[$index]["VRUNITITEM"] = 0.0;
                    }
                    
                    if($field_struct_name == "VRTOTAITEM"){
                        $products_cp[$index][$field_struct_name] = 0.0;
                    }
                    
                    if($field_struct_name == "CUSTOMVAR3"){
                        $products_cp[$index][$field_struct_name] = '';
                    }
                    
                    if($field_struct_name == "VRDESCITEM"){
                        $products_cp[$index][$field_struct_name] = 0.0;
                    }
                    
                    if($field_struct_name == "CDLOCALESTOQ"){
                        $products_cp[$index]["CDLOCALESTOQ"] = " ";
                    }
                    
                    if($field_struct_name == "CDALMOXARIFE"){
                        $products_cp[$index]["CDALMOXARIFE"] = " ";
                    }
                    
                    if($field_struct_name == "NRLOTEESTQ"){
                        $products_cp[$index]["NRLOTEESTQ"] = " ";
                    }
                    
                    if($field_struct_name == "NRSUBLOTE"){
                        $products_cp[$index]["NRSUBLOTE"] = " ";
                    }
                }
                
                if($field_struct_name == "VRDESCITEM"){
                    $this->verifyNegativeValue($products_cp[$index][$field_struct_name], $field_struct_name, null);
                }
                if($field_struct_name == "VRUNITITEM"){
                    $this->verifyNegativeValue($products_cp[$index]["VRUNITITEM"], $field_struct_name, $products_cp[$index]["CDARVPROD"]);
                }
                if($field_struct_name == "VRTOTAITEM"){
                    $this->verifyNegativeValue($products_cp[$index][$field_struct_name], $field_struct_name, $products_cp[$index]["CDARVPROD"]);
                }
                
                // todas as alterações nos produtos precisam ser feitas antes do index incrementar +1
                $index += 1;
            }
        }
        
        if($tax["CDTIPOOPER"] == '02' && $tax["IDENTRSAIDOP"] == 'S'){
            $index = 0;
            $products = $products_cp;
            foreach($products as $product){
                $vrStock = $this->estoque->consultaCustoQuantidadeProduto($tax["CDFILIAL"], $product["CDPRODUTO"], $tax["DTENTRSAID"], 
                                                                '03', $product["CDALMOXARIFE"], 
                                                                $product["CDLOCALESTOQ"], $product["NRLOTEESTQ"], 
                                                                $product["NRSUBLOTE"], $tax["CDTIPOOPER"]);
                if($vrStock["ExistsVr"] == false){
                    array_push($this->taxErrors, "O valor unitário do produto está zerado. " . $product["CDPRODUTO"]); 
                }else if($vrStock["ExistsTp"] == false){
                    array_push($this->taxErrors, "O tipo de custo não foi informado. " . $product["CDPRODUTO"]);
                }else{
                    $products_cp[$index]["VRUNITITEM"] = $vrStock["VRCUSTOPROD"];
                }
                $index += 1;
            }
        }
        $tax_cp["Produtos"] = $products_cp;
        $index = 0;
        foreach($products as $product){
            $prodFili = $this->factory->getInfoProdFili($products_cp[$index]["CDPRODESTO"], $tax["CDFILIAL"]);
            if($prodFili != false){
                $products_cp[$index]["IDATUESTPROD"] = $prodFili['IDCNTRESTOQ'];
            }else{
                array_push($this->taxErrors, 'O produto ' . $products_cp[$index]["CDPRODUTO"] . ' não tem parametrização de estoque relacionado à atualização de estoque ou não está ativo no sistema. "Produto x Filial".');
            }
            $index += 1;
        }
        if(sizeof($this->taxErrors) > 0){
            return array("messages" => $this->taxErrors, "taxAjusted" => []);
        }
        foreach($this->charge_struct as $field_struct_name => $field_struct_value){
            if(sizeof($charges) == 0){
                continue;
            }
            foreach($charges as $charge){
                if(array_key_exists($field_struct_name, $charge)){
                    $field_value = $charge[$field_struct_name];
                    if($this->charge_struct[$field_struct_name]["REQUIRED"] == true){
                        $cdencargo = isset($charge["CDENCARGO"]) ? $charge["CDENCARGO"] : "CDENCARGO não informado.";
                        $this->validateRequired($this->charge_struct, $field_struct_name, $field_value, $cdencargo, 'charges'); 
                    }
                    if($field_value != '' && isset($field_value)){
                        //$this->validateType($this->charge_struct, $field_struct_name, $field_value);
                        //$this->validateSize($this->charge_struct, $field_struct_name, $field_value);
                    }
                    
                    if($field_struct_name == "CDENCARGO"){
                    $isValid = $this->factory->validateCharges($charge[$field_struct_name]);
                    if($isValid == false){
                        array_push($this->taxErrors, 'O encargo ' . $field_value . ' não é um encargo válido.');
                    }
                }
                }else{
                    $cdencargo = isset($charge["CDENCARGO"]) ? $charge["CDENCARGO"] : "CDENCARGO não informado.";
                    $this->validateRequired($this->charge_struct, $field_struct_name, $field_value, $cdencargo, 'charges');
                }
                
            }
        }
        if(sizeof($this->taxErrors) > 0){
            return array("messages" => $this->taxErrors, "taxAjusted" => []);
        }
        foreach($this->dac_struct as $field_struct_name => $field_struct_value){
            if(sizeof($dacs) <= 0){
                continue;
            }
            foreach($dacs as $dac){
                if(array_key_exists($field_struct_name, $dac)){
                    $field_value = $dac[$field_struct_name];
                    if($this->dac_struct[$field_struct_name]["REQUIRED"] == true){
                        $this->validateRequired($this->dac_struct, $field_struct_name, $field_value, null); 
                    }
                    if($field_value != '' && isset($field_value)){
                        //$this->validateType($this->dac_struct, $field_struct_name, $field_value);
                        //$this->validateSize($this->dac_struct, $field_struct_name, $field_value);
                    }
                }else{
                    $this->validateRequired($this->dac_struct, $field_struct_name, $field_value, null);
                }
            }
        }
        if(sizeof($this->taxErrors) > 0){
            return array("messages" => $this->taxErrors, "taxAjusted" => []);
        }
        
        //IDCTRLESTQ -> PARAMFILIAL && IDATUESTTPOP -> CDTIPOOPER
        $tax_cp["IDCTRLESTQ"] = $this->verificaControleEstoqueFilialPorTipoOp($tax_cp);
        $tax_cp["IDSISTEMA"] = $tax_cp["IDENTRSAIDOP"] == 'E' ? 'DFE' : 'DFS';
        $tax_cp["NRORG"] = $this->environment->getNrOrgTrab();
        $tax_cp["NRLANCTONF"] = null;
        $tax_cp["NRLANCESTOQ"] = null;
        $tax_cp["DTLANCAMENNF"] = date('d/m/Y');
        $tax_cp["IDORIGDESTNF"] = $tax["CDTIPOOPER"] == '01' ? 'F' : 'L';
        $tax_cp["IDINTEREST"] = $this->factory->getIdinterest($tax_cp["CDEMPRESA"], $tax_cp["CDINSCESTA"], $tax_cp["CDCLIENTE"], $tax_cp["CDFORNECED"], $tax_cp["CDFILIAL"], $tax_cp["IDORIGDESTNF"], $this->environment->getNrOrgTrab());
        $tax_cp["CDGRUPOFISCAL"] = $this->factory->procedureConsultaGrupofiscal($tax_cp["IDORIGDESTNF"], $tax_cp["CDFORNECED"], $tax_cp["CDFILIAL"], $tax_cp["IDENTRSAIDOP"], $tax_cp["CDTIPOOPER"]);
        $tax_cp["DTPROCESSA"] = $this->factory->getDTPROCESSA($tax_cp["CDFILIAL"], $tax_cp["NRORG"]);
        if($this->verificaVigenciaIEForaDaValidade($tax_cp["CDINSCESTA"], $tax_cp["CDEMPRESA"], $tax_cp["DTENTRSAID"])){
            array_push($this->taxErrors, "A inscrição estadual encontra-se fora da data de vigência.");
        }
        if(is_null($tax_cp["DTPROCESSA"])){
            $tax_cp["DTPROCESSA"] = date("d/m/Y");
        }else{
            $date_exploded = explode(" ", $tax_cp["DTPROCESSA"]);
            $tax_cp["DTPROCESSA"] = $date_exploded[0];
        }
        $tax_cp["Produtos"] = $products_cp;
        $tax_cp["Encargos"] = $charges;
        $tax_cp["DadosAdicionais"] = $dacs;
        $returnArray = array("messages" => $this->taxErrors, "taxAjusted" => $tax_cp);
        return $returnArray;
    }
    
    public function verificaVigenciaIEForaDaValidade($ie, $emp, $dtEntrSaid){
        $response = $this->factory->vigenciaIE($ie, $emp, $dtEntrSaid);
        if($response == false){
            return true;
        }else if(isset($response)){
            if(isset($response["CDINSCESTA"])){
                return false;
            }
        }else{
            return true;
        }
    }
    
    public function retornaDadosProcessFilial($filial, $organizacao) {
        $conditions[] = array(
            'columnName' => 'CDFILIAL',
            'operator' => '=',
            'value' => $filial,
        );
        $conditions[] = array(
            'columnName' => 'NRORG',
            'operator' => '=',
            'value' => $organizacao,
        );

        $dataSet = $this->crudService->getFilteredDataSet('paramestoque_processamento', $conditions);
        $rows = $dataSet->getRows();

        if (!count($rows))
            throw new \Exception('Parametrização geral não encontrada.');

        return $this->getDateObject($rows[0]["DTPROCESSA"]);
    }
    
    public function getDateObject($dateString) {
        if(!is_object($dateString)) {
            $dateFormat = DateUtil::FORMATO_BRASILEIRO;
            $dateObject = DateUtil::getDataDeString($dateString, $dateFormat, false);
        } else
            $dateObject = $dateString;

        return $dateObject;
    }
    
    public function verifyCustomBool($value, $name){
        if($value != ''){
            if($value < 0 || $value > 1){
                array_push($this->taxErrors, "O item " . $name . " não pode receber valores: Menores que 0 ou maiores que 1. Valor recebido: " . $value);
            }
        }
    }
    
    public function verifyNegativeValue($value, $name, $cdarvprod = null){
        if($value != ''){
            if($value < 0){
                if($cdarvprod != null){
                    array_push($this->taxErrors, "O item " . $name . ", do produto " . $cdarvprod . " não pode receber valor negativo. Valor recebido: " . $value);
                }else{
                    array_push($this->taxErrors, "O item " . $name . " não pode receber valor negativo. Valor recebido: " . $value);
                }
            }
        }
    }
    
    public function verificaControleEstoqueFilialPorTipoOp($tax){
        if($tax["CDTIPOOPER"] == "02"){
            return $this->verfifyEstoqueParam($tax["CDFILIALDEST"], $tax["CDTIPOOPER"], $tax["IDENTRSAIDOP"]);
        }else{
            return $this->verfifyEstoqueParam($tax["CDFILIALORIG"], $tax["CDTIPOOPER"], $tax["IDENTRSAIDOP"]);
        }
    }
    
    public function verfifyEstoqueParam($filial, $cdtipooper, $identrsaidop){
        $stockControl = $this->factory->filialControlaEstoque($filial);
        if($stockControl == false){
            return 'N';
        }
        if($stockControl == 'S'){
            $stockRefresh = $this->factory->tipooperControlaEstoque($cdtipooper, $identrsaidop);
            if($stockRefresh == 'S'){
                return 'S';
            }else{
                return 'N';
            }
        }else{
            return 'N';
        }
    }
    
    public function validateRequired($struct, $field_struct_name, $field_value, $struct_identify, $struct_name = 'tax'){
        if($struct[$field_struct_name]["REQUIRED"] == true){
            if($field_value == '' || !isset($field_value)){
                $field_value = $field_value == '' ? 'vazio' : $field_value;
                $msg = 'O ' .$field_struct_name. ' é obrigatório. Valor recebido: ' .$field_value. '. ';
                switch ($struct_name){
                    case 'products':
                        $msg .= 'CDPRODUTO = ' . $struct_identify;
                        break;
                        
                    case 'charges':
                        $msg .= 'CDENCARGO = ' . $struct_identify;
                        break;
                        
                    default:
                        break;
                }
                array_push($this->taxErrors, $msg);
            } 
        }
    }
    
    public function validateSize($struct, $field_struct_name, $field_value){
        if($struct[$field_struct_name]["SIZE"] == "INDEFINIDO"){
            return;
        }
        if($field_struct_name == 'DSDADOADIC'){
            if(strlen($field_value) > $struct[$field_struct_name]["SIZE"]){
                array_push($this->taxErrors, 'O ' .$field_struct_name. ' está com o tamanho incorreto. Tamanho recebido: ' .strlen($field_value). '. Tamanho requerido: '. $struct[$field_struct_name]["SIZE"] . '.');
            }
        }else if($field_struct_name == "QTITEMPROD" || $field_struct_name == "QTRECEBE"){
            $fieldValueExploded = explode('.', $field_value);
            if(sizeof($fieldValueExploded) > 1){
                $fieldValueExploded = $fieldValueExploded[1];
                if($struct[$field_struct_name]["OBS"]  < strlen($fieldValueExploded)){
                    array_push($this->taxErrors, 'O ' .$field_struct_name. ' está com o tamanho incorreto de casas decimais. Tamanho recebido: ' .strlen($fieldValueExploded). '. Tamanho máximo requerido: ' . $struct[$field_struct_name]["OBS"] . '. Valor do atributo: ' . $field_value . '.');
                } 
            }
        }else if($field_struct_name == "CUSTOMVAR1" || $field_struct_name == "CUSTOMVAR2"){ 
            if($struct[$field_struct_name]["SIZE"]  < strlen($field_value)){
                array_push($this->taxErrors, 'O ' .$field_struct_name. ' está com o tamanho incorreto de casas decimais. Tamanho recebido: ' .strlen($field_value). '. Tamanho máximo requerido: ' . $struct[$field_struct_name]["SIZE"] . '. Valor do atributo: ' . $field_value . '.');
            } 
        }else if($struct[$field_struct_name]["SIZE"] != strlen($field_value)){
            array_push($this->taxErrors, 'O ' .$field_struct_name. ' está com o tamanho incorreto. Tamanho recebido: ' .strlen($field_value). '. Tamanho requerido: '. $struct[$field_struct_name]["SIZE"] . '. Valor do atributo: ' . $field_value . '.');
        } 
    }
    
    public function validateType($struct, $field_struct_name, $field_value){
        if($struct[$field_struct_name]["TYPE"] != gettype($field_value)){
            array_push($this->taxErrors, 'O ' .$field_struct_name. ' não corresponde ao tipo de variável especificado. Tipo recebido: ' .gettype($field_value). '.'. ' Tipo requerido: '. $struct[$field_struct_name]["TYPE"] . '. Valor do atributo: ' . $field_value . '.');
        }
    }
    
    public function validateIdentifyTax($identrsaidop){
        if($identrsaidop != 'E' && $identrsaidop != 'S'){
            return "O valor do campo IDENTRSAIDOP está incorreto, apenas os valores E ou S são permitidos. Valor recebido: " . $identrsaidop;
        }
        return false;
    }
    
    public function validateTipooperTax($cdtipooper){
        if($cdtipooper != '01' && $cdtipooper != '02'){
            return "O valor do campo CDTIPOOPER está incorreto, apenas os valores 01 ou 02 são permitidos. Valor recebido: " . $cdtipooper;
        }
        return false;
    }
    
    public function validate64base($value){
        $base64_decode = base64_decode($value); 
        if ($base64_decode == false){
            return false;
        } else {
            return true;
        }
    }
    
    public function validateDate($date, $format = 'd/m/y'){
        $formattedDate = \DateTime::createFromFormat($format, $date);
        return $formattedDate && $formattedDate->format('d/m/Y') == $date;
    }
    
    public function estandarChangeRequired($tax, $products){
        if($tax["CDTIPOOPER"] == "01" && $tax["IDENTRSAIDOP"] == "E"){
            if(array_key_exists("NRINSJURFORN", $this->tax_struct)){
                $this->tax_struct["NRINSJURFORN"]["REQUIRED"] = true;
            }else{
                array_push($this->taxErrors, "O campo NRINSJURFORN não existe no TAX_STRUCT, por favor, contate o admin.");
            }
        }
        
        if($tax["CDTIPOOPER"] == "02"){
            if(array_key_exists("CDFILIALDEST", $this->tax_struct)){
                $this->tax_struct["CDFILIALDEST"]["REQUIRED"] = true;
            }else{
                array_push($this->taxErrors, "O campo CDFILIALDEST não existe no TAX_STRUCT, por favor, contate o admin.");
            }
        }
        
        if($tax["IDENTRSAIDOP"] == "E"){
            foreach($products as $prd){
                if(array_key_exists("VRUNITITEM", $this->prod_struct)){
                    $this->prod_struct["VRUNITITEM"]["REQUIRED"] = true;
                }else{
                    array_push($this->taxErrors, "O campo VRUNITITEM não existe no PROD_STRUCT, por favor, contate o admin.");
                }
                
                if(array_key_exists("VRTOTAITEM", $this->prod_struct)){
                    $this->prod_struct["VRTOTAITEM"]["REQUIRED"] = true;
                }else{
                    array_push($this->taxErrors, "O campo VRTOTAITEM não existe no PROD_STRUCT, por favor, contate o admin.");
                }
            }
        }
    }
    
    public function validateQtRecebeField($taxCdtipooper, $products){
        foreach($products as $product){
            if(array_key_exists("QTITEMPROD", $product)){
                if(array_key_exists("CDPRODUTO", $product)){
                    if(array_key_exists("QTRECEBE", $product)){
                        $qtdItemProd = $product["QTITEMPROD"];
                        $cdproduto = $product["CDPRODUTO"];
                        $qtrecebe = $product["QTRECEBE"];
                        
                        $this->validateQtdRecebe($qtrecebe, $taxCdtipooper, $qtdItemProd, $cdproduto);
                    }else{
                        array_push($this->taxErrors, "O campo QTRECEBE não existe na nota fiscal -> produtos.");
                    }
                }else{
                    array_push($this->taxErrors, "O campo CDPRODUTO não existe na nota fiscal -> produtos.");
                }
            }else{
                array_push($this->taxErrors, "O campo QTITEMPROD não existe na nota fiscal -> produtos.");
            }
        }
    }
    
    public function validateQtdRecebe($qtrecebe, $taxCdtipooper, $qtdItemProd, $cdproduto){
        if($taxCdtipooper == "02"){
            $msgErrorQntRecebe = $this->validateMsgQntRecebe($qtrecebe, $qtdItemProd, $cdproduto);
            if($msgErrorQntRecebe != false){
                array_push($this->taxErrors, $msgErrorQntRecebe);
            }
        }else if($taxCdtipooper == "01"){
            if($qtdItemProd > $qtrecebe){
                $geraFaturaDevolucao = true;
            }
        }
    }
    
    public function validateMsgQntRecebe($qntRecebe, $qtdItemProd, $cdproduto){
        if($qntRecebe != $qtdItemProd){
            return "Por ser uma guia de despacho, o valor de QTRECEBE deve ser igual ao valor de QTITEMPROD. Valores recebidos: QTRECEBE: " . $qntRecebe . " E QTITEMPROD: " . $qtdItemProd . ". CDPRODUTO: ". $cdproduto;
        }
        return false;
    }
    
    public function saveTax($tax, $devolucao = false){
        if($tax["IDENTRSAIDOP"] == 'E'){
            $keys = $this->factory->geraCorpoNotaEntrada(
                        $tax["CDFILIAL"],
                        $tax["CDFILIRECE"],
                        $tax["CDEMPRESA"],
                        $tax["CDTIPOOPER"],
                        $tax["CDSERIE"],
                        $tax["CDCLIENTE"],
                        $tax["IDSISTEMA"],
                        $tax["IDCTRLESTQ"],
                        $tax["NRLANCTONF"], 
                        NULL, NULL, NULL,  NULL, NULL, NULL, NULL, NULL, NULL, 
                        $tax["NRLANCESTOQ"],
                        $tax["DTENTRSAID"],
                        NULL, NULL, 
                        $tax["VRNOTAFISC"], 
                        NULL, 
                        $tax["DTLANCAMENNF"], 
                        $tax["DTEMISSAO"], 
                        NULL, NULL, NULL);
                        
            $tax["NRLANCTONF"] = $keys["P_PRXLANCTONF"];                                    
            $tax["NRLANCESTQ"] = $keys["P_PRXLANCESTQ"];
            $keys["CDFILIAL"] = $tax["CDFILIAL"];
            
            
            
        }else{
            $keys = $this->factory->geraCorpoNota(
                $tax["CDFILIAL"],
                $tax["CDFILIEMIT"],
                $tax["CDEMPRESA"],
                $tax["CDTIPOOPER"],
                $tax["CDSERIE"],
                $tax["CDCLIENTE"],
                $tax["IDSISTEMA"],
                $tax["IDCTRLESTQ"],
                NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
                $tax["DTENTRSAID"],
                NULL, NULL, NULL,
                $tax["DTLANCAMENNF"]
                );
            $tax["NRLANCTONF"] = $keys["P_PRXLANCTONF"];                                    
            $tax["NRLANCESTQ"] = $keys["P_PRXLANCESTQ"];
            $keys["CDFILIAL"] = $tax["CDFILIAL"];
        }
        if(isset($tax["CDFILIAL"], $tax["NRLANCTONF"]) && !$devolucao){
            $this->factory->updateNf2Pending($tax["CDFILIAL"], $tax["NRLANCTONF"], 'P', $tax["CDOPERADOR"], $tax["NRNOTAFISC"]);
        }else{
            $this->factory->updateNf2Pending($tax["CDFILIAL"], $tax["NRLANCTONF"], 'P', $tax["CDOPERADOR"], null);
        }
        return array("messages"=>$this->entryErrors, "keys" => $keys, "taxUpdated" => $tax);
    }
    
    public function updateCharges($charges, $cdfilial, $nrlanctonf){
        try{
            $this->factory->insertDefaultCharges($cdfilial, $nrlanctonf);  
            foreach($charges as $encargo){
                $this->factory->updateCharge($encargo["CDENCARGO"], $encargo["VRITEMENCA"], $cdfilial, $nrlanctonf);
            }
            return array("SuccessCharge" => true, "MessagesCharge" => []);
        }catch(\Exception $e){
            return array("SuccessCharge" => false, "MessagesCharge" => [$e->getMessage()]);
        }
    }
    
    public function saveProducts(
                                $nrautoforn,
                                $products, 
                                $cdEmpresa, 
                                $cdIncesta, 
                                $tipoOper, 
                                $cdForneced, 
                                $cdfilial,
                                $nrlanctonf,
                                $dtentrSaid, 
                                $cdoperador, 
                                $idorigdestnf,
                                $identrsaidop,
                                $grupofisc = null,
                                $idinterest = null,
                                $cdfilirece = null,
                                $cdfiliemit = null
                                ){
        
        $productsUpdated = $products;
        $index = 0;
        $arrayProdsBaixados = array();
        try{
            //o php nao mantem a alteração apos o foreach
            foreach($products as $produto){
                
                $this->factory->procedureGeraNotaFiscalProduto(
                        $cdfilial, 
                        $nrlanctonf,
                        $produto["CDPRODUTO"], 
                        $produto["CDARVPROD"], 
                        $produto["DSPRODEMIS"],  
                        $produto["QTITEMPROD"], 
                        $produto["VRUNITITEM"],  
                        $produto["VRDESCITEM"], 
                        $produto["CDALMOXARIFE"], 
                        $produto["CDLOCALESTOQ"], 
                        $produto["NRLOTEESTQ"], 
                        $produto["NRSUBLOTE"], 
                        null, null, 
                        $produto["IDATUESTPROD"],  
                        0);
                        
                $productsUpdated[$index]["NRSEQITPROD"] = $nrseqitprod = $this->factory->getMaxNrSeqItProd($cdfilial, $nrlanctonf);
                
                if($identrsaidop == 'E'){
                    $this->factory->procedureImpostoEntradaProduto(
                        $cdEmpresa, 
                        $cdIncesta, 
                        $tipoOper, 
                        $cdForneced, 
                        $cdfilial,
                        $nrlanctonf,
                        $dtentrSaid, 
                        'E',
                        $cdoperador, 
                        $grupofisc,
                        $idinterest,
                        $produto["CDARVPROD"], 
                        '',
                        $idorigdestnf,
                        $cdfilirece,
                        $cdfiliemit,
                        null, 
                        ($produto["VRUNITITEM"] * $produto["QTITEMPROD"]) - $produto["VRDESCITEM"], 
                        null, null);
                                                                    
                    $c_aliquota = $this->factory->getAliquota($cdfilial, $nrlanctonf);
                    if(is_array($c_aliquota) && $c_aliquota != false){
                        foreach($c_aliquota as $imposto){
                            $this->factory->insertTrabitproimpos($cdfilial, $nrlanctonf, $imposto, $productsUpdated[$index]);
                        } 
                        $this->factory->deleteAliqtempprod($cdfilial, $nrlanctonf);
                        $this->factory->deleteIncitemp($cdfilial, $nrlanctonf);
                    }
                    
                    if($tipoOper == '01' && $identrsaidop == 'E'){
                        $this->factory->updateQtRecebe($cdfilial, $nrlanctonf, $productsUpdated[$index]["NRSEQITPROD"], $productsUpdated[$index]["QTRECEBE"]);
                        
                        if($this->existeAfLancada){
                            $itemAf = $this->factory->getAf($nrautoforn, $productsUpdated[$index]["CDPRODUTO"]);
                            if($itemAf != false){
                                $productsUpdated[$index]["CDMARCA"] = $itemAf["CDMARCA"];
                                $productsUpdated[$index]["CDFILDEST"] = $itemAf["CDFILDEST"];
                                $productsUpdated[$index]["CDFILLANC"] = $itemAf["CDFILLANC"];
                                $productsUpdated[$index]["QTPROGENTAF"] = $itemAf["QTPROGENTAF"];
                                $productsUpdated[$index]["VRPREUNIAF"] = $itemAf["VRPREUNIAF"];
                                $productsUpdated[$index]["DTPROGENTAF"] = $itemAf["DTPROGENTAF"];
                                $this->factory->insertNfRelacAf($cdfilial, $productsUpdated[$index]["CDFILLANC"], $nrlanctonf,
                                                                $productsUpdated[$index]["CDFILDEST"], $nrautoforn, $productsUpdated[$index]["CDPRODUTO"], 
                                                                $productsUpdated[$index]["CDMARCA"], $productsUpdated[$index]["DTPROGENTAF"], $productsUpdated[$index]["QTPROGENTAF"],
                                                                $productsUpdated[$index]["VRPREUNIAF"]
                                                                );
                                $this->factory->updateMarcaAf($productsUpdated[$index]["CDMARCA"], $cdfilial, $nrlanctonf, $productsUpdated[$index]["NRSEQITPROD"], $productsUpdated[$index]["DTPROGENTAF"], $nrautoforn, $productsUpdated[$index]["CDFILDEST"]);  
                                $this->factory->procedureBaixaAF($cdfilial, $nrlanctonf, $productsUpdated[$index]["NRSEQITPROD"], 'I', $productsUpdated[$index]["CDARVPROD"],
                                                                $productsUpdated[$index]["CDARVPROD"], $productsUpdated[$index]["CDPRODUTO"], $productsUpdated[$index]["CDPRODUTO"], 
                                                                $productsUpdated[$index]["CDMARCA"], $productsUpdated[$index]["CDMARCA"], $productsUpdated[$index]["QTRECEBE"], $productsUpdated[$index]["QTRECEBE"]);
                                $this->baixouAf = true;
                                array_push($arrayProdsBaixados, $productsUpdated[$index]);
                            }
                        }
                    }
                }
                
                $index += 1;
            }
            return array("SuccessProducts" => true, "MessagesProducts" => [], "Updated" => $productsUpdated, "afBaixada" => $this->baixouAf, "produtosBaixados" => $arrayProdsBaixados);
        }catch(\Exception $e){
            return array("SuccessProducts" => false, "MessagesProducts" => [$e->getMessage()], "Updated" => $productsUpdated, "afBaixada" => $this->baixouAf, "produtosBaixados" => $arrayProdsBaixados);
        }
    }
    
    public function saveDacs($dadosAdic, $cdfilial, $nrlanctonf){
        try{
            foreach($dadosAdic as $dac){
                $nrdadoadic = $this->factory->getMaxNrDadoAdic($cdfilial, $nrlanctonf);
                $this->factory->insertAdditionalData($dac["DSDADOADIC"], $cdfilial, $nrlanctonf, $nrdadoadic);
            }
            return array("SuccessDacs" => true, "MessagesDacs" => [], "afBaixada" => $this->baixouAf);
        }catch(\Exception $e){
            return array("SuccessDacs" => false, "MessagesDacs" => [$e->getMessage()], "afBaixada" => $this->baixouAf);
        }
    }
    
    public function insertNfTot($cdfilial, $nrlanctonf){
        try{
            $c_trabImposNfTot = $this->factory->getTrabImposNfTot($cdfilial, $nrlanctonf);
            if(is_array($c_trabImposNfTot) && $c_trabImposNfTot != false){
                foreach($c_trabImposNfTot as $imposto){
                    $this->factory->insertTrabImposNfTot($cdfilial, $nrlanctonf, $imposto);
                } 
            }
            return array("SuccessTot" => true, "MessagesTot" => []);
        }catch(\Exception $e){
            return array("SuccessTot" => false, "MessagesTot" => [$e->getMessage()]);
        }
    }

    public function closeTax($tax){
        $this->factory->procedureFechamento($tax);
        $lanctoestoq = $this->factory->getLanctoEstoq($tax["CDFILIAL"], $tax["NRLANCESTQ"], $tax["NRORG"]);
        if (!empty($lanctoestoq) && $tax["IDCTRLESTQ"] == 'S')
             $this->verificaIrregularidades($lanctoestoq);
        return $this->validaErrosEAvisos($tax["CDFILIAL"], $tax["NRLANCTONF"], ($tax['IDENTRSAIDOP'] === 'E') ? $tax['CDFILIRECE'] : $tax['CDFILIEMIT'], false);
    }
    
    public function insertNfRelacAf($nrautoforn, $cdfilial, $nrlanctonf, $produtos){
        $this->factory->insert($nrautoforn, $cdfilial, $nrlanctonf);
    }
    
    public function verificaIrregularidades($lanctoestoq, $seqItemCodes = null) {
        $concat_cdarvprod_irregular_products = '';
        
        #checks for irregularities
        $irregularProducts = $this->retornaProdutosIrregulares($lanctoestoq, $seqItemCodes);
        foreach($irregularProducts as $produto){
            //$entitiesIrregularProducts = Produto::findOneByCdprodutoAndNrorg($produto["CDPRODUTO"], $this->environment->getNrOrgTrab());
            $entitiesIrregularProducts = $this->factory->getProductOneByCdprodutoAndNrorg($produto["CDPRODUTO"], $this->environment->getNrOrgTrab());
            $concat_cdarvprod_irregular_products .= $entitiesIrregularProducts["CDPRODUTO"].'. ';
        }
        
        if (!empty($irregularProducts))
            throw new \Exception ('A confirmação da operação faria com que a posição de estoque de alguns itens se tornasse irregular. Código dos produto(s): ' . $concat_cdarvprod_irregular_products);
    }
    
    public function retornaProdutosIrregulares($lanctoestoq, $seqItens = null) {
        $nrmovilote = $lanctoestoq["CDFILIAL"].$lanctoestoq["NRLANCESTQ"];

        $produtosIrregulares = $this->factory->getMovilote($nrmovilote, $this->environment->getNrOrgTrab());
        if(!is_null($seqItens)) {
            $itlanctoest = $this->buscaItlanctoest(
                $lanctoestoq["CDFILIAL"], $lanctoestoq["NRLANCESTQ"],
                $this->environment->getNrOrgTrab()
            );

            $seqProds = array();
            foreach($itlanctoest as $item)
                if(in_array($item->getNrsequitem(), $seqItens))
                    $seqProds[] = $item->getCdproduto();

            $produtosIrregularesInSeqItens = array();

            foreach ($produtosIrregulares as $produto)
                if(in_array($produto["CDPRODUTO"], $seqProds))
                    $produtosIrregularesInSeqItens[] = $produto;

            return $produtosIrregularesInSeqItens;
        }
        
        if($produtosIrregulares == false){
            $produtosIrregulares = [];
        }

        return $produtosIrregulares;
    }
    
    public function buscaItlanctoest($cdfilial, $nrlancestq, $nrorg, $idevolestoq = null) {
        #checks parameter existence
        if(is_null($idevolestoq))
            #searches for every existent item
            $itlanctoest = Itlanctoest::findByCdfilialAndNrlancestqAndNrorg(
                $cdfilial, $nrlancestq, $nrorg
            );
        else
            #searches for certain items
            $itlanctoest = Itlanctoest::findByCdfilialAndNrlancestqAndIdevolestoqAndNrorg(
                $cdfilial, $nrlancestq, $idevolestoq, $nrorg
            );

        # @var \Estoque\Entities\Itlanctoest $itlanctoest
        return $itlanctoest;
    }
    
    public function validaErrosEAvisos($filial, $lancamento, $filialMovimentada, $forcaFechamento) {
        try {
            $connection = $this->entityManager->getConnection();
            $connection->beginTransaction();
            $this->confereErrosAvisosNota->setNotaFiscalEntity($filial, $lancamento);
            $this->errosAvisos = $this->confereErrosAvisosNota->confereErros($filialMovimentada);

            if (count($this->errosAvisos) > 0) {

                $bloqueia = false;
  
                foreach ($this->errosAvisos as $erro) {
                   if($erro["IDERROAVISO"] == 'B') $bloqueia = true;
                   
                   array_push($this->closeErrors, $erro["DSERROAVISO"]);
                }
            }

            $this->entityManager->flush();
            $connection->commit();
            
            return array("messages" => $this->closeErrors);
        } catch (\Exception $e) {
            $connection->rollback();
            throw $e;
        }
    }
    
    public function deletaNf($cdfilial, $nrlanctonf, $products = array(), $tipoOper = null, $identrsaidop = null){
        if($tipoOper == '01' && $identrsaidop == 'E' && $this->existeAfLancada){
            foreach($products as $product){
                $this->factory->procedureBaixaAF($cdfilial, $nrlanctonf, $product["NRSEQITPROD"], 'E', $product["CDARVPROD"],
                                                $product["CDARVPROD"], $product["CDPRODUTO"], $product["CDPRODUTO"], 
                                                $product["CDMARCA"], $product["CDMARCA"], $product["QTRECEBE"], 
                                                $product["QTRECEBE"]);
            }
        }
        
        $this->factory->procedureDeletaNf($cdfilial, $nrlanctonf, 'I');
        $this->factory->procedureDeletaNf($cdfilial, $nrlanctonf, 'C');
    }
    
    public function verificaDevolucao(){
        return $this->devolucao;
    }
    
    public function insertDevolucao($cdfilial, $nrlanctonf){
        $cdtipooperDev = $this->factory->getTipoOperDevolucao();
        $products = $this->factory->getProductsDevo($cdfilial, $nrlanctonf);
        if($products != false){
            if($cdtipooperDev == false && sizeof($products) > 0){
                return;
            }else{
                $nf = $this->factory->getNf($cdfilial, $nrlanctonf);
                $devolucao["CDFILIAL"] = $nf["CDFILIAL"];
                $devolucao["CDFILIEMIT"] = $nf["CDFILIRECE"];
                $devolucao["CDEMPRESA"] = $nf["CDEMPRESA"];
                $devolucao["CDINSCESTA"] = $nf["CDINSCESTA"];
                $devolucao["CDTIPOOPER"] = $cdtipooperDev;
                $devolucao["CDSERIE"] = $nf["CDSERIEENTR"];
                $devolucao["CDCLIENTE"] = $nf["CDFORNECED"];
                $devolucao["IDSISTEMA"] = 'DFS';
                $devolucao["IDCTRLESTQ"] = $this->verfifyEstoqueParam($devolucao["CDFILIEMIT"], $devolucao["CDTIPOOPER"], 'S');
                $devolucao["DTENTRSAID"] = $nf["DTENTRSAID"];
                $devolucao["DTLANCAMENNF"] = $nf["DTLANCAMENNF"];
                $devolucao["CDOPERADOR"] = $nf["CDOPERGERA"];
                $devolucao["IDORIGDESTNF"] = $nf["IDORIGDESTNF"];
                $devolucao["IDENTRSAIDOP"] = 'S';
                $devolucao["NRORG"] = $this->environment->getNrOrgTrab();
                $devolucao["DTPROCESSA"] = $this->factory->getDTPROCESSA($devolucao["CDFILIAL"], $devolucao["NRORG"]);
                $taxSaved = $this->saveTax($devolucao, true);
                
                if(empty($taxSaved["messages"])){
                    $devolucao = $taxSaved["taxUpdated"];
                    $this->factory->insertItemNotaFisc($cdfilial, $nrlanctonf, $devolucao["CDFILIAL"], $devolucao["NRLANCTONF"]);
                    $this->saveProducts(
                                    null,
                                    $products, 
                                    $devolucao["CDEMPRESA"], 
                                    $devolucao["CDINSCESTA"], 
                                    $devolucao["CDTIPOOPER"], 
                                    $devolucao["CDCLIENTE"],
                                    $devolucao["CDFILIAL"],
                                    $devolucao["NRLANCTONF"],
                                    $devolucao["DTENTRSAID"], 
                                    $devolucao["CDOPERADOR"], 
                                    $devolucao["IDORIGDESTNF"], 
                                    $devolucao["IDENTRSAIDOP"]);
                    $this->closeTax($devolucao);
                }else{
                    return;
                }
            }
        }
    }
    
    public function taxApproved($cdfilial, $nrlanctonf){
        $this->factory->taxApproved($cdfilial, $nrlanctonf);
    }
    
    public function getSeqAnexo($cdfilial, $nrlanctonf){
        return $this->factory->getSeqAnexo($cdfilial, $nrlanctonf);
    }    
    
    public function saveAnexos($cdfilial, $nrlanctonf, $anexos){
        return array("SuccessAnexos" => true, "MessagesAnexos" => []);
        try{
            foreach($anexos as $anexo){
                if($anexo != ''){
                    
                    
                    //$subFolder = str_replace(array('producao/', 'homologacao/'), "", $dir);
                    
                    //$this->zGravaFile('2', $name, $anexo, $diretorio, $subFolder);
                    $this->factory->insertAnexo($cdfilial, $nrlanctonf, $anexo, $this->getSeqAnexo($cdfilial, $nrlanctonf));
                }
            }
            return array("SuccessAnexos" => true, "MessagesAnexos" => [], "afBaixada" => $this->baixouAf);
        }catch(\Exception $e){
            return array("SuccessAnexos" => false, "MessagesAnexos" => [$e->getMessage()], "afBaixada" => $this->baixouAf);
        }
    }
    
    /**
     * zGravaFile
     * Grava os dados no diretorio das NFe
     *
     * @param  string $tpAmb     ambiente
     * @param  string $filename  nome do arquivo
     * @param  string $data      dados a serem salvos
     * @param  string $subFolder
     * @param  string $anomes
     * @throws Exception\RuntimeException
     */
     //$file['name'], $fileUpload, $file['name'], rtrim($dir, '/'), rtrim($subFolder, '/')
    public function zGravaFile(
        $filename = '',
        $data = '',
        $cdRelac = '',
        $diretorio = '', 
        $subFolder = ''
    ) {
        $tmpFile = sys_get_temp_dir().DIRECTORY_SEPARATOR.'xmlNota'.uniqid().'.xml';
        file_put_contents($tmpFile, $data);
        $file = file_get_contents($tmpFile);
        $file    = base64_encode($file);

        $file = 'data: '.mime_content_type($tmpFile).';base64,'.$file;
        
        $lastModify = filectime($tmpFile);

        $file = array(
            "name" => $filename, 
            "lastModified" => $lastModify,
            "lastModifiedDate" => '',
            "webkitRelativePath" => '',
            "type" => '',
            "size"  => filesize($tmpFile),
            "b64File" => $file);
            
        $row['XML']    = array();
        $row['XML'][0] = $file;
        
        $this->fileUploader->uploadFilesInRow($row, 'XML', '');
        unlink($tmpFile);
        
        $fileServerLink = $row['XML'][0]['path'];
        
        $this->insertIntoRelacFileServer(str_replace(".", "", explode('.', $filename)[0]), $diretorio, $fileServerLink, 'xml');
        
        return $row['XML'][0]['path'];
    }
    
    private function insertIntoRelacFileServer($chNFe, $diretorio, $fileServerLink, $dsExtensao) {

        $sql = "INSERT
                INTO RELACFILESERVER
                  (
                    CDRELAC,
                    DIRETORIO,
                    FILESERVERLINK,
                    DSEXTENSAO,
				    DTINCLUSAO,
					CDOPERINCLUSAO,
					NRORGINCLUSAO,
				    IDATIVO,
				    DTULTATU,
				    NRORGULTATU,
				    CDOPERULTATU,
                    NRORG
                  )
                  VALUES
                  (
                    :CDRELAC,
                    :DIRETORIO,
                    :FILESERVERLINK,
                    :DSEXTENSAO,
				    :DTINCLUSAO,
					:CDOPERINCLUSAO,
					:NRORGINCLUSAO,
					:IDATIVO,
					:DTULTATU,
					:NRORGULTATU,
					:CDOPERULTATU,
                    :NRORG
                  )";
        
        $params = array(
            "CDRELAC"        => $chNFe,
            "DIRETORIO"      => $diretorio,
            "DSEXTENSAO"     => $dsExtensao,
            "FILESERVERLINK" => $fileServerLink,
            "NRORG"          => $this->environment->getNrOrgTrab()
        );

		$params = $this->adicionaCampos($params, true);
		
        $std = $this->connection->prepare($sql);
        return $std->execute($params);
    }
    
	protected function adicionaCampos($params, $is_new) {
        $nrorg = $this->environment->getNrorgTrab();
		$operador = $this->environment->getCdOperador();
		$currentTime = $this->environment->getCurrentTime()->format("d/m/Y H:i:s");
		
		
		if($is_new == true) {
			$params['DTINCLUSAO'] = $currentTime;
			$params['CDOPERINCLUSAO'] = $operador;
			$params['NRORGINCLUSAO'] = $nrorg;
			$params['IDATIVO'] = 'S';
			$params['NRORG'] = $nrorg;
		}
		
		$params['DTULTATU'] = $currentTime;
		$params['NRORGULTATU'] = $nrorg;
		$params['CDOPERULTATU'] = $operador;
		
		return $params;
    }
}