/******************************************************************************/
/* Sistemas Integrados TECNISA                                                */
/******************************************************************************/
/* Nome: CALC_FATURAMENTO                                                     */
/*                                                                            */
/* Descrio:                                                                 */
/* Calcula datas de faturamento para um determinado mes baseando-se na        */
/* Periodicidade de faturamento e nos Feriados.                               */
/*                                                                            */
/* Criao:                                                                   */
/* 30/05/2003 - Gustavo Nosseis dos Santos                                    */
/******************************************************************************/
/* PARAMETROS:                                                                */
/*                                                                            */
/* P_CDFILIAL     - Cdigo da Filial                                          */
/* P_CDCLIENTE    - Cdigo do Cliente                                         */
/* P_CDPERIENTR   - Cdigo da Periodicidade de Fatura                         */
/* P_DTINICIAL    - Data do Inicio do Mes                                     */
/* P_NRMESES      - Numero de meses a serem calculados                        */
/******************************************************************************/
/* @C:\WIN_V2\SQL\END_CONV\ORACLE\8671_VMNSTP_CALC_FATURAMENTO.SQL            */
/******************************************************************************/
CREATE OR REPLACE
PROCEDURE  CALC_FATURAMENTO
  (P_CDFILIAL     IN VARCHAR2,
   P_CDCLIENTE    IN VARCHAR2,
   P_CDPERIENTR   IN VARCHAR2,
   P_DTINICIAL    IN DATE,
   P_NRMESES      IN NUMBER) IS
   V_CONTAMES   NUMBER;
   V_IDTIPODIA  VARCHAR2(1);
   V_IDDIANUTIL VARCHAR2(1);
   V_DTINIAUX   DATE;
   V_DTFATURVMN DATE;
   V_CONTA      NUMBER;
BEGIN
  SELECT IDTIPODIA,IDDIANUTIL
  INTO V_IDTIPODIA, V_IDDIANUTIL
  FROM PERIENTR
  WHERE CDPERIENTR = P_CDPERIENTR;
  V_DTINIAUX := P_DTINICIAL;
  FOR V_CONTAMES IN 1..P_NRMESES LOOP
    V_CONTA := 1;
    SELECT COUNT(*) INTO V_CONTA
    FROM CALEFATURVMN
    WHERE
       CDCLIENTE  = P_CDCLIENTE AND
       CDFILIAL   = P_CDFILIAL  AND
       TO_CHAR(DTFATURVMN,'MM/YYYY') = TO_CHAR(V_DTINIAUX,'MM/YYYY');
    IF V_CONTA > 0 THEN
       DELETE FROM CALEFATURVMN
       WHERE
         CDCLIENTE   = P_CDCLIENTE AND
         CDFILIAL   = P_CDFILIAL  AND
         TO_CHAR(DTFATURVMN,'MMYYYY') = TO_CHAR(V_DTINIAUX,'MMYYYY');
    END IF;
    IF V_IDTIPODIA = 'M' THEN
       MES_FATURAMENTO(P_CDFILIAL,P_CDCLIENTE, P_CDPERIENTR,V_DTINIAUX,V_IDDIANUTIL);
    ELSE
       IF V_IDTIPODIA = 'S' THEN
          SEM_FATURAMENTO(P_CDFILIAL,P_CDCLIENTE,P_CDPERIENTR,V_DTINIAUX,V_IDDIANUTIL);
       END IF;   
    END IF;
    V_DTINIAUX := LAST_DAY(V_DTINIAUX) + 1;
  END LOOP;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('CALC_FATURAMENTO','4.11.151'); END;
/



