/*
 Tecnisa - Tecnologia em Informtica

 Nome: Limpeza de Dados do Estoque

 Criao:
 26/09/2001 - Roberto A. Lopes Martins

 @C:\Temp\GR\4007_STPESTO_Limpeza_Estoque.SQL
*/

CREATE OR REPLACE PROCEDURE LIMPEZA_ESTOQUE_GR(
   P_DTLIMPEZA IN DATE)

AS

   V_CONTADOR   NUMBER;
   V_CDFILIPROC VARCHAR2(04);
   V_NRLANCESTQ VARCHAR2(20);
   V_NRSEQUITEM NUMBER;

   V_ERR0R      VARCHAR2(2000);

BEGIN

   EXECUTE IMMEDIATE 'ALTER TRIGGER ATUALIZA_DELETE_LOGMOVIEST DISABLE';

   SELECT MAX(CDFILIAL)
   INTO V_CDFILIPROC
   FROM PARAMGERAL;

   FOR C_FILIAL IN (SELECT DISTINCT CDFILIMOVI AS CDFILIAL
                    FROM LANCTOESTOQ
                    WHERE DTLANCESTQ <= P_DTLIMPEZA
                    ORDER BY CDFILIMOVI) LOOP

      FOR C_POSESTDIA IN (SELECT CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE, CDPRODUTO, MAX(DTPOSIESTQ) AS DTPOSIESTQ
                          FROM POSESTDIA
                          WHERE CDFILIAL    = C_FILIAL.CDFILIAL AND
                                DTPOSIESTQ <= P_DTLIMPEZA
                          GROUP BY CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE, CDPRODUTO) LOOP

         DELETE POSESTDIA
         WHERE (CDFILIAL     = C_FILIAL.CDFILIAL)               AND
               (CDPRODUTO    = C_POSESTDIA.CDPRODUTO)    AND
               (CDALMOXARIFE = C_POSESTDIA.CDALMOXARIFE) AND
               (CDLOCALESTOQ = C_POSESTDIA.CDLOCALESTOQ) AND
               (NRLOTEESTQ   = C_POSESTDIA.NRLOTEESTQ)   AND
               (NRSUBLOTE    = C_POSESTDIA.NRSUBLOTE)    AND
               (DTPOSIESTQ   < C_POSESTDIA.DTPOSIESTQ);

      END LOOP;
      COMMIT;

      FOR C_POSESTCONS IN (SELECT CDPRODUTO, MAX(DTPOSESTCON) AS DTPOSESTCON
                           FROM POSESTCONS
                           WHERE CDFILIAL    = C_FILIAL.CDFILIAL AND
                                 DTPOSESTCON <= P_DTLIMPEZA
                           GROUP BY CDPRODUTO) LOOP

         DELETE POSESTCONS
         WHERE (CDFILIAL    = C_FILIAL.CDFILIAL)      AND
               (CDPRODUTO   = C_POSESTCONS.CDPRODUTO) AND
               (DTPOSESTCON < C_POSESTCONS.DTPOSESTCON);

      END LOOP;
      COMMIT;

      FOR C_RETIRADAPCP IN (SELECT DISTINCT C.CDFILIALLPCP, C.NRLANCESTQ
                            FROM RETIRADAPCP C, LANCTOESTOQ L
                            WHERE C.CDFILIALLPCP = L.CDFILIAL        AND
                                  C.NRLANCESTQ   = L.NRLANCESTQ      AND
                                  L.CDFILIMOVI   = C_FILIAL.CDFILIAL AND
                                  L.DTLANCESTQ  <= P_DTLIMPEZA) LOOP

         DELETE ITEMRETPCP
         WHERE CDFILIALITLPCP = C_RETIRADAPCP.CDFILIALLPCP AND
               NRLANCESTQ     = C_RETIRADAPCP.NRLANCESTQ;

         DELETE RETIRADAPCP
         WHERE CDFILIALLPCP = C_RETIRADAPCP.CDFILIALLPCP AND
               NRLANCESTQ   = C_RETIRADAPCP.NRLANCESTQ;

      END LOOP;
      COMMIT;

      FOR C_RETIRADA IN (SELECT DISTINCT C.CDFILANCESTQ, C.NRLANCESTQ
                         FROM RETIRADA C, LANCTOESTOQ L
                         WHERE C.CDFILANCESTQ = L.CDFILIAL        AND
                               C.NRLANCESTQ   = L.NRLANCESTQ      AND
                               L.CDFILIMOVI   = C_FILIAL.CDFILIAL AND
                               L.DTLANCESTQ   < P_DTLIMPEZA) LOOP

         DELETE RETIRADA
         WHERE CDFILANCESTQ = C_RETIRADA.CDFILANCESTQ AND
               NRLANCESTQ   = C_RETIRADA.NRLANCESTQ;

      END LOOP;
      COMMIT;

      FOR C_PREVRETI IN (SELECT DISTINCT DTPREVRETI
                         FROM PREVRETI
                         WHERE CDFILIAL    = C_FILIAL.CDFILIAL AND
                               DTPREVRETI  < P_DTLIMPEZA) LOOP

         DELETE PREVRETI
         WHERE CDFILIAL   = C_FILIAL.CDFILIAL AND
               DTPREVRETI = C_PREVRETI.DTPREVRETI;

      END LOOP;
      COMMIT;

      FOR C_PREVCONS IN (SELECT DISTINCT DTPREVCONS
                         FROM PREVCONS
                         WHERE CDFILIAL    = C_FILIAL.CDFILIAL AND
                               DTPREVCONS  < P_DTLIMPEZA) LOOP

         DELETE PREVCONS
         WHERE CDFILIAL   = C_FILIAL.CDFILIAL AND
               DTPREVCONS = C_PREVCONS.DTPREVCONS;

      END LOOP;
      COMMIT;

      FOR C_CARDADIA IN (SELECT DISTINCT DTCARDAPIO
                         FROM CARDADIA
                         WHERE CDFILIAL    = C_FILIAL.CDFILIAL AND
                               DTCARDAPIO  < P_DTLIMPEZA) LOOP

         DELETE CARDADIA
         WHERE CDFILIAL   = C_FILIAL.CDFILIAL AND
               DTCARDAPIO = C_CARDADIA.DTCARDAPIO;

      END LOOP;
      COMMIT;

      FOR C_RETIRADAESTO IN (SELECT DISTINCT C.CDFILIALLAN, C.NRLANCESTQ
                             FROM RETIRADAESTO C, LANCTOESTOQ L
                             WHERE C.CDFILIALLAN  = L.CDFILIAL        AND
                                   C.NRLANCESTQ   = L.NRLANCESTQ      AND
                                   L.CDFILIMOVI   = C_FILIAL.CDFILIAL AND
                                   L.DTLANCESTQ   < P_DTLIMPEZA) LOOP

         DELETE RETIRADAESTO
         WHERE CDFILIALLAN = C_RETIRADAESTO.CDFILIALLAN AND
               NRLANCESTQ  = C_RETIRADAESTO.NRLANCESTQ;

      END LOOP;
      COMMIT;

      FOR C_ITEMVENDA IN (SELECT DISTINCT I.CDFILIALEST, I.NRLANCESTQ
                          FROM ITEMVENDA I, VENDA V
                          WHERE I.CDFILIAL = C_FILIAL.CDFILIAL AND
                                V.DTVENDA  < P_DTLIMPEZA       AND
                                I.CDFILIAL   = V.CDFILIAL      AND
                                I.CDCAIXA    = V.CDCAIXA       AND
                                I.NRSEQVENDA = V.NRSEQVENDA    AND
                                I.NRLANCESTQ IS NOT NULL) LOOP

         UPDATE ITEMVENDA I
         SET I.CDFILIALEST = NULL,
             I.NRLANCESTQ  = NULL
         WHERE CDFILIALEST = C_ITEMVENDA.CDFILIALEST AND
               NRLANCESTQ  = C_ITEMVENDA.NRLANCESTQ;
      END LOOP;
      COMMIT;

      FOR C_ITEMVENDA IN (SELECT DISTINCT I.CDFILIALEST, I.NRLANCESTQ
                          FROM COMPITVENDA I, VENDA V
                          WHERE I.CDFILIAL = C_FILIAL.CDFILIAL AND
                                V.DTVENDA  < P_DTLIMPEZA       AND
                                I.CDFILIAL   = V.CDFILIAL      AND
                                I.CDCAIXA    = V.CDCAIXA       AND
                                I.NRSEQVENDA = V.NRSEQVENDA    AND
                                I.NRLANCESTQ IS NOT NULL) LOOP

         UPDATE COMPITVENDA I
         SET I.CDFILIALEST = NULL,
             I.NRLANCESTQ  = NULL
         WHERE CDFILIALEST = C_ITEMVENDA.CDFILIALEST AND
               NRLANCESTQ  = C_ITEMVENDA.NRLANCESTQ;
      END LOOP;
      COMMIT;

      FOR C_AJURELACRET IN (SELECT DISTINCT A.CDFILIAL, A.NRLANCESTQ
                            FROM AJURELACRET A, LANCTOESTOQ L
                            WHERE A.CDFILIAL    = L.CDFILIAL        AND
                                  A.NRLANCESTQ  = L.NRLANCESTQ      AND
                                  L.CDFILIMOVI  = C_FILIAL.CDFILIAL AND
                                  L.DTLANCESTQ  < P_DTLIMPEZA) LOOP

         DELETE AJURELACRET
         WHERE CDFILIAL   = C_AJURELACRET.CDFILIAL AND
               NRLANCESTQ = C_AJURELACRET.NRLANCESTQ;

      END LOOP;
      COMMIT;

      FOR C_AJURELACRET IN (SELECT DISTINCT A.CDFILIALRET, A.NRLANCESTRET
                            FROM AJURELACRET A, LANCTOESTOQ L
                            WHERE A.CDFILIALRET  = L.CDFILIAL        AND
                                  A.NRLANCESTRET = L.NRLANCESTQ      AND
                                  L.CDFILIMOVI   = C_FILIAL.CDFILIAL AND
                                  L.DTLANCESTQ   < P_DTLIMPEZA) LOOP

         DELETE AJURELACRET
         WHERE CDFILIALRET  = C_AJURELACRET.CDFILIALRET AND
               NRLANCESTRET = C_AJURELACRET.NRLANCESTRET;

      END LOOP;
      COMMIT;

      FOR C_CTRLMOVIESTQ IN (SELECT DISTINCT C.CDFILIALENTR, C.NRLANESTENTR
                             FROM CTRLMOVIESTQ C, LANCTOESTOQ L
                             WHERE C.CDFILIALENTR = L.CDFILIAL        AND
                                   C.NRLANESTENTR = L.NRLANCESTQ      AND
                                   L.CDFILIMOVI   = C_FILIAL.CDFILIAL AND
                                   L.DTLANCESTQ   < P_DTLIMPEZA) LOOP

         DELETE CTRLMOVIESTQ
         WHERE CDFILIALENTR = C_CTRLMOVIESTQ.CDFILIALENTR AND
               NRLANESTENTR = C_CTRLMOVIESTQ.NRLANESTENTR;

      END LOOP;
      COMMIT;

      FOR C_CTRLMOVIESTQ IN (SELECT DISTINCT C.CDFILIALSAID, C.NRLANESTSAID
                             FROM CTRLMOVIESTQ C, LANCTOESTOQ L
                             WHERE C.CDFILIALSAID = L.CDFILIAL        AND
                                   C.NRLANESTSAID = L.NRLANCESTQ      AND
                                   L.CDFILIMOVI   = C_FILIAL.CDFILIAL AND
                                   L.DTLANCESTQ   < P_DTLIMPEZA) LOOP

         DELETE CTRLMOVIESTQ
         WHERE CDFILIALSAID = C_CTRLMOVIESTQ.CDFILIALSAID AND
               NRLANESTSAID = C_CTRLMOVIESTQ.NRLANESTSAID;

      END LOOP;
      COMMIT;

      FOR C_NFABASTEROTA IN (SELECT DISTINCT C.CDFILIAL, C.NRLANCESTQ
                             FROM NFABASTEROTA C, LANCTOESTOQ L
                             WHERE C.CDFILIAL   = L.CDFILIAL        AND
                                   C.NRLANCESTQ = L.NRLANCESTQ      AND
                                   L.CDFILIMOVI = C_FILIAL.CDFILIAL AND
                                   L.DTLANCESTQ < P_DTLIMPEZA) LOOP

         DELETE NFABASTEROTA
         WHERE CDFILIAL   = C_NFABASTEROTA.CDFILIAL AND
               NRLANCESTQ = C_NFABASTEROTA.NRLANCESTQ;

      END LOOP;
      COMMIT;

      FOR C_PREVPDVLESTO IN (SELECT DISTINCT C.CDFILANCESTQ, C.NRLANCESTQ
                             FROM PREVPDVLESTO C, LANCTOESTOQ L
                             WHERE C.CDFILANCESTQ = L.CDFILIAL        AND
                                   C.NRLANCESTQ   = L.NRLANCESTQ      AND
                                   L.CDFILIMOVI   = C_FILIAL.CDFILIAL AND
                                   L.DTLANCESTQ   < P_DTLIMPEZA) LOOP

         DELETE PREVPDVLESTO
         WHERE CDFILANCESTQ = C_PREVPDVLESTO.CDFILANCESTQ AND
               NRLANCESTQ   = C_PREVPDVLESTO.NRLANCESTQ;

      END LOOP;
      COMMIT;

      FOR C_CUSTOCMPPROD IN (SELECT DISTINCT C.CDFILLANCEST, C.NRLANCESTQ
                             FROM CUSTOCMPPROD C, LANCTOESTOQ L
                             WHERE C.CDFILLANCEST = L.CDFILIAL        AND
                                   C.NRLANCESTQ   = L.NRLANCESTQ      AND
                                   L.CDFILIMOVI   = C_FILIAL.CDFILIAL AND
                                   L.DTLANCESTQ   < P_DTLIMPEZA) LOOP

         DELETE CUSTOCMPPROD
         WHERE CDFILLANCEST = C_CUSTOCMPPROD.CDFILLANCEST AND
               NRLANCESTQ   = C_CUSTOCMPPROD.NRLANCESTQ;

      END LOOP;
      COMMIT;

      FOR C_LANCTOESTOQ IN (SELECT DISTINCT DTLANCESTQ
                            FROM LANCTOESTOQ
                            WHERE CDFILIMOVI  = C_FILIAL.CDFILIAL AND
                                  DTLANCESTQ  < P_DTLIMPEZA) LOOP

         DELETE LANCTOESTOQ
         WHERE CDFILIMOVI = C_FILIAL.CDFILIAL AND
               DTLANCESTQ = C_LANCTOESTOQ.DTLANCESTQ;

      END LOOP;
      COMMIT;

      FOR C_ROMANEIO IN (SELECT CDFILIAL, NRROMANEIO
                         FROM ROMANEIO
                         WHERE CDFILIEMITRO = C_FILIAL.CDFILIAL AND
                               DTROMANEIO   < P_DTLIMPEZA) LOOP
         DELETE ROMANEIONF
         WHERE CDFILIAL   = C_ROMANEIO.CDFILIAL AND
               NRROMANEIO = C_ROMANEIO.NRROMANEIO;

         DELETE ROMANEIO
         WHERE CDFILIAL   = C_ROMANEIO.CDFILIAL AND
               NRROMANEIO = C_ROMANEIO.NRROMANEIO;

         COMMIT;
      END LOOP;

      NOVO_CODIGO('LANCTOEST' || V_CDFILIPROC, V_NRLANCESTQ);

      INSERT INTO LANCTOESTOQ
      (CDFILIAL,NRLANCESTQ,CDOPERADOR,IDTPLANCTO,DTLANCESTQ,CDFILIMOVI)
      VALUES
      (V_CDFILIPROC, SUBSTR(V_NRLANCESTQ,11,10), '000000000999', '0', P_DTLIMPEZA, C_FILIAL.CDFILIAL);

      V_NRSEQUITEM := 1;

      FOR C_IMPLANTACAO IN (SELECT CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE,
                                   CDPRODUTO, QTESTOQDIA, VRESTOQDIA, VRESTOQBRUT
                            FROM POSESTDIA P
                            WHERE CDFILIAL   = C_FILIAL.CDFILIAL AND
                                  QTESTOQDIA <> 0                 AND
                                  DTPOSIESTQ = (SELECT MAX(DTPOSIESTQ)
                                                FROM POSESTDIA
                                                WHERE CDFILIAL     = P.CDFILIAL     AND
                                                      CDALMOXARIFE = P.CDALMOXARIFE AND
                                                      CDLOCALESTOQ = P.CDLOCALESTOQ AND
                                                      NRLOTEESTQ   = P.NRLOTEESTQ   AND
                                                      NRSUBLOTE    = P.NRSUBLOTE    AND
                                                      CDPRODUTO    = P.CDPRODUTO    AND
                                                      DTPOSIESTQ  <= P_DTLIMPEZA)) LOOP


         INSERT INTO ITLANCTOEST
            (CDFILIAL, NRLANCESTQ, NRSEQUITEM, CDPRODUTO,
             QTTOTLANCTO, VRUNILANCTO, VRTOTLANCTO, IDTIPOMOVI,
             DTLANCMOVI, IDORDEMCLC, CDPRODMOVI, QTLANCTOEST,
             VRLANCTOBRUT, VRLANCTOEST, CDFILIMOVI, IDEVOLESTOQ,
             CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE)
         VALUES
            (V_CDFILIPROC, SUBSTR(V_NRLANCESTQ,11,10), LPAD(TO_CHAR(V_NRSEQUITEM), 4, '0'), C_IMPLANTACAO.CDPRODUTO,
             C_IMPLANTACAO.QTESTOQDIA, (C_IMPLANTACAO.VRESTOQDIA/C_IMPLANTACAO.QTESTOQDIA), C_IMPLANTACAO.VRESTOQDIA, '0',
             P_DTLIMPEZA, '0', C_IMPLANTACAO.CDPRODUTO, C_IMPLANTACAO.QTESTOQDIA,
             C_IMPLANTACAO.VRESTOQBRUT, C_IMPLANTACAO.VRESTOQDIA, C_FILIAL.CDFILIAL, 'S',
             C_IMPLANTACAO.CDALMOXARIFE, C_IMPLANTACAO.CDLOCALESTOQ, C_IMPLANTACAO.NRLOTEESTQ, C_IMPLANTACAO.NRSUBLOTE);

         COMMIT;
         V_NRSEQUITEM := V_NRSEQUITEM + 1;
      END LOOP;
   END LOOP;

   DELETE FROM MOVILOTE;
   COMMIT;

   DELETE FROM CONSPLAN;
   COMMIT;

   DELETE FROM CONSPLANSE;
   COMMIT;

   EXECUTE IMMEDIATE 'ALTER TRIGGER ATUALIZA_DELETE_LOGMOVIEST ENABLE';

EXCEPTION
WHEN OTHERS THEN
   V_ERR0R := SQLERRM(SQLCODE);
   EXECUTE IMMEDIATE 'ALTER TRIGGER ATUALIZA_DELETE_LOGMOVIEST ENABLE';
   RAISE_APPLICATION_ERROR(-20101,V_ERR0R);
END;
/


